#include "stdafx.h"
#include <glut.h>
#include <math.h>

float WinWidth  = 600.0;
float WinHeight = 400.0;
float max_a = 100.0; //.  
float min_a = 50.0; //.  
int   angle = 90;  //.     
int   angstep = 3; // 
bool *DirRot; //  
bool *Dir;    //  
int  *Angle;  //    [-angle;angle]
bool *IsRot; //  ?

int x_el = int(WinWidth/max_a); //- .  
int y_el = int(WinHeight/max_a);//- .  

void Display() {
	glClear(GL_COLOR_BUFFER_BIT); // 
	for(int i=0; i<y_el; i++) { //
		for(int j=0; j<x_el; j++) { //
			int tmp=i*x_el+j;
			glPushMatrix();
			glTranslatef(max_a*(j+1.0/2),max_a*(i+1.0/2),0.0); //  
			glRotatef(Angle[tmp],0.0,0.0,1.0); //
			glScalef((max_a-(max_a-min_a)*abs(Angle[tmp])/angle)/max_a,
				     (max_a-(max_a-min_a)*abs(Angle[tmp])/angle)/max_a,
					 1.0); //  
			glColor3ub(0,0,0); // 
			glBegin(GL_QUADS); // 
				glVertex2f(0.0,-max_a/2);
				glVertex2f(-max_a/2,0.0);
				glVertex2f(0.0,max_a/2);
				glVertex2f(max_a/2,0.0);
			glEnd();
			glPopMatrix();
			if(IsRot[tmp]) { //    -  
				if(DirRot[tmp]) Angle[tmp]+=angstep;
				else            Angle[tmp]-=angstep;
			}
		}
	}
	glutSwapBuffers(); // 
}

void Timer(int value) {
	for(int i=0; i<y_el; i++) { //
		for(int j=0; j<x_el; j++) { //
			int tmp=i*x_el+j;
			if(IsRot[tmp]) {
				if(Angle[tmp]>= angle || //      
				   Angle[tmp]<=-angle || //[-angle;angle]
				   ((Angle[tmp]>=0&& Angle[tmp]<angstep&& DirRot[tmp]) ||
				   (-Angle[tmp]>=0&&-Angle[tmp]<angstep&&!DirRot[tmp]))) { //   
					IsRot[tmp]=false; //  

					if(Angle[tmp]>=angle) {
						Angle[tmp]=angle; // 
						DirRot[tmp]=false; //   
					}
					else if(Angle[tmp]<=-angle) {
						Angle[tmp]=-angle;
						DirRot[tmp]=true; //   
					}
					else Angle[tmp]=0;

					if(j==0&&!Dir[i])                    Dir[i]=true; // 
					else if(j==x_el-1&&Dir[i]) Dir[i]=false;// 
					else if(Dir[i]) tmp=i*x_el+j+1;
					else            tmp=i*x_el+j-1;
					IsRot[tmp]=true; //      
					if(DirRot[tmp]) Angle[tmp]+=angstep;
					else            Angle[tmp]-=angstep;
					
					if(i>0) {//      
						for(int g=0; g<x_el; g++) { //   , ...
							if(IsRot[(i-1)*x_el+g]) break; //  
							if(g==x_el-1) { //  , ...
								tmp=(i-1)*x_el+j;
								IsRot[tmp]=true; //   
								if(DirRot[tmp]) Angle[tmp]+=angstep;
								else            Angle[tmp]-=angstep;
							}
						}
					}
					if(i<y_el-1) {//      
						for(int g=0; g<x_el; g++) {
							if(IsRot[(i+1)*x_el+g]) break;
							if(g==x_el-1) {
								tmp=(i+1)*x_el+j;
								IsRot[tmp]=true;
								if(DirRot[tmp]) Angle[tmp]+=angstep;
								else            Angle[tmp]-=angstep;
							}
						}
					}
				}
			}
		}
	}
	glutPostRedisplay(); // Display()
	glutTimerFunc(10,Timer,0); // 
}

void Initialize() {
	DirRot = new bool[x_el*y_el];
	Angle  = new int [x_el*y_el];
	IsRot  = new bool[x_el*y_el];
	Dir    = new bool[y_el];
	for(int i=0; i<y_el; i++) { //
		Dir[i]=true;
		for(int j=0; j<x_el; j++) { //
			int tmp=i*x_el+j;
			Angle[tmp]=0;
			IsRot[tmp]=false;
			if((i+j)%2==0) DirRot[tmp]=true;
			else           DirRot[tmp]=false;
		}
	}
	IsRot[(y_el-1)*x_el+0]=true; // ,    
	if(DirRot[(y_el-1)*x_el+0])
		Angle[(y_el-1)*x_el+0]=angstep;
	else
		Angle[(y_el-1)*x_el+0]=-angstep;
	glClearColor(1.0, 1.0, 1.0, 1.0); // 
	glMatrixMode(GL_PROJECTION); //   
	glLoadIdentity(); //  
	gluOrtho2D(0.0, WinWidth, 0.0, WinHeight); //   
	glMatrixMode(GL_MODELVIEW); //  - 
}

int main(int argc, char** argv) {
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB);
	glutInitWindowSize(WinWidth, WinHeight);
	glutInitWindowPosition(100, 200);
	glutCreateWindow("DDFellow");
	glutDisplayFunc(Display);
	glutTimerFunc(0,Timer,0);
	Initialize();
	glutMainLoop();
	delete[]DirRot; DirRot=NULL;
	delete[]Angle;  Angle =NULL;
	delete[]Dir;    Dir   =NULL;
	delete[]IsRot;  IsRot =NULL;
	return 0;
}